<template>
    <div class="col-xs-12">
        <h1>Products</h1>
        <a v-link="{ path: '/add-product' }">Add product</a>

        <table>
        </table>
    </div>
</template>

<script>
    import $ from 'jquery';
    import 'jquery-ui';
    import 'jquery-ui/themes/base/base.css';
    import 'jquery-ui/themes/base/theme.css';
    import 'jquery-ui/themes/base/datepicker.css';
    import 'jquery-ui/ui/widgets/datepicker';
    import dt from 'datatables.net';
    import 'datatables.net-dt/css/jquery.dataTables.css'
    import 'yadcf';
    import moment from 'moment';

    dt(window, $);

    export default {
        data: function () {
            return {
                columns: [],
                options: {},
                yadcf_columns: []
            }
        },
        ready: function () {
            this.getColumns().then(function (res) {
//				console.log(res);
                var self = this;
////				this.columns = res;
                res.forEach(function (column, index) {
//					console.log(column.code);
                    var element = {};
                    if (column.system) {
                        element = {
                            data: column.code,
                            title: column.name
                        }
                        if (column.code === 'name') {
                            element.render = function (data, type, row) {
                                return '<a href="#!/product/' + row._id + '">' + data + '</a>';
                            }
                        }
                    } else {
                        element = {
                            "data": "attributes." + column.code,
                            "title": column.name
                        }
                    }

                    var yadcf_element = {
                        column_number: index,
                        filter_type: column.type
                    }
                    if (column.type === 'date') {
                        var datetimepickerOptions = {
                            timeFormat: 'HH:MM:SS',
                            dateFormat: 'yy-mm-dd',
                            timeInput: true
                        };
                        yadcf_element.datepicker_type = 'jquery-ui';
                        yadcf_element.date_format = 'yyyy-mm-dd HH:MM:SS';
                        yadcf_element.moment_date_format = 'YYYY-MM-DD hh:mm:ss';
                        yadcf_element.filter_plugin_options = datetimepickerOptions;
                    }
//					console.log(element);
                    self.columns.push(element);
                    self.yadcf_columns.push(yadcf_element);
                });
//				console.log(this.columns);
                this.buildDt();
            });
        },
        methods: {
            getColumns: function () {
                return this.$http.get('/api/v1/product-attributes/get-columns').then(function (res) {
                    return res.data
                })
            },
            buildDt: function () {
                console.log(this);
                self = this;
                this.options = {
                    processing: true,
                    serverSide: true,
                    lengthMenu: [[25, 50, 100, 200], [25, 50, 100, 200]],
                    ajax: {
                        url: '/api/v1/products',
                        data: function (d) {
                            d.columnsCount = self.columns.length
                        }
                    },
                    columns: self.columns
                }
                var datatable = $('table').DataTable(this.options);

                yadcf.init(datatable, this.yadcf_columns);
            },
        },
        components: {},
    }
</script>

<style>

</style>
